Overview
CDP Cloudera Lakehouse Optimizer Service does the iceberg table maintenance, it allows users to define policies to schedule iceberg spark actions to perform regular maintenance.
Version information
Version : 0.9.160
License information
License : Apache 2.0
Terms of service : null
URI scheme
Schemes : HTTPS
Consumes
-
application/json
Produces
-
application/json
Paths
Perform policy change operations on a table.
POST /api/v1/lakehouseopt/changeTablePolicy
Description
Perform operations on a table to associate new policies, remove existing policies, replace existing policies.
Parameters
| Type | Name | Schema |
|---|---|---|
Body |
input |
Responses
| HTTP Code | Description | Schema |
|---|---|---|
200 |
Expected response to a valid request. |
|
default |
The default response on an error. |
Create policy to table associations.
POST /api/v1/lakehouseopt/createAssociations
Description
Associate set of tables per namespace to a policy.
Parameters
| Type | Name | Schema |
|---|---|---|
Body |
input |
Responses
| HTTP Code | Description | Schema |
|---|---|---|
200 |
Expected response to a valid request. |
|
default |
The default response on an error. |
Create a new policy.
POST /api/v1/lakehouseopt/createPolicy
Description
Create a new policy with a name.
Parameters
| Type | Name | Schema |
|---|---|---|
Body |
input |
Responses
| HTTP Code | Description | Schema |
|---|---|---|
200 |
Expected response to a valid request. |
|
default |
The default response on an error. |
create associations of a table and policies.
POST /api/v1/lakehouseopt/createTablePoliciesAssociations
Description
create associations of a table and policies.
Parameters
| Type | Name | Schema |
|---|---|---|
Body |
input |
Responses
| HTTP Code | Description | Schema |
|---|---|---|
200 |
Expected response to a valid request. |
|
default |
The default response on an error. |
Delete a policy definition for a resource.
POST /api/v1/lakehouseopt/deletePolicy
Description
Delete a policy definition which is applicable on a provided resource. Resource could be a namespace or a table. If ''*'' is provided for namespace, then it deletes all policies across all namespaces. Otherwise, namespace and table must be provided.
Parameters
| Type | Name | Schema |
|---|---|---|
Body |
input |
Responses
| HTTP Code | Description | Schema |
|---|---|---|
200 |
Expected response to a valid request. |
|
default |
The default response on an error. |
Downloads the policy definition for a particular policy version.
POST /api/v1/lakehouseopt/downloadPolicy
Description
Downloads the policy scripts and/or arguments for a particular policy version. Version is identified by a unique ID.
Parameters
| Type | Name | Schema |
|---|---|---|
Body |
input |
Responses
| HTTP Code | Description | Schema |
|---|---|---|
200 |
Expected response to a valid request. |
|
default |
The default response on an error. |
Execute a policy on a table.
POST /api/v1/lakehouseopt/executePolicy
Description
Execute a policy on a table. If dryRun flag is set to true, then it will only do the policy evaluation without actually performing any action on the table.
Parameters
| Type | Name | Schema |
|---|---|---|
Body |
input |
Responses
| HTTP Code | Description | Schema |
|---|---|---|
200 |
Expected response to a valid request. |
|
default |
The default response on an error. |
Get all associated namespaces for a policy.
POST /api/v1/lakehouseopt/getAssociatedNamespaces
Description
Get all namespaces along with a flag to indicate if they are associated to the policy.
Parameters
| Type | Name | Schema |
|---|---|---|
Body |
input |
Responses
| HTTP Code | Description | Schema |
|---|---|---|
200 |
Expected response to a valid request. |
|
default |
The default response on an error. |
Get all associated tables for a policy
POST /api/v1/lakehouseopt/getAssociatedTables
Description
Return tables per namespaces along with a flag to indicate if they are associated to the policy.
Parameters
| Type | Name | Schema |
|---|---|---|
Body |
input |
Responses
| HTTP Code | Description | Schema |
|---|---|---|
200 |
Expected response to a valid request. |
|
default |
The default response on an error. |
Get policy association details.
POST /api/v1/lakehouseopt/getAssociationDetails
Description
Get details about policy association. It contains directAssociation and starAssociation. 'directAssociation' will provide details on set of policies which are associated with individual tables and 'starAssociation" will provide details on policies which are associated at namespace level.
Parameters
| Type | Name | Schema |
|---|---|---|
Body |
input |
Responses
| HTTP Code | Description | Schema |
|---|---|---|
200 |
Expected response to a valid request. |
|
default |
The default response on an error. |
Get policy to table associations.
POST /api/v1/lakehouseopt/getAssociations
Description
Get list of tables associated per namespace for a policy.
Parameters
| Type | Name | Schema |
|---|---|---|
Body |
input |
Responses
| HTTP Code | Description | Schema |
|---|---|---|
200 |
Expected response to a valid request. |
|
default |
The default response on an error. |
Fetches CLO Data Hub for an environment.
POST /api/v1/lakehouseopt/getCloDatahub
Description
Fetches CLO Data Hub for an environment.
Parameters
| Type | Name | Schema |
|---|---|---|
Body |
input |
Responses
| HTTP Code | Description | Schema |
|---|---|---|
200 |
Expected response to a valid request. |
|
default |
The default response on an error. |
Fetches Data Hub CRN for an environment.
POST /api/v1/lakehouseopt/getDatahubCrn
Description
Fetches Data Hub CRN for an environment.
Parameters
| Type | Name | Schema |
|---|---|---|
Body |
input |
Responses
| HTTP Code | Description | Schema |
|---|---|---|
200 |
Expected response to a valid request. |
|
default |
The default response on an error. |
Performs health check on CLO components.
POST /api/v1/lakehouseopt/getHealth
Description
Returns the CLO component (Scheduler, dispatcher, DAO) wise health check result. Service specific result will include the state of the service (healthy or unhealthy) and additional details.
Parameters
| Type | Name | Schema |
|---|---|---|
Body |
input |
Responses
| HTTP Code | Description | Schema |
|---|---|---|
200 |
Expected response to a valid request. |
|
default |
The default response on an error. |
Get all namespaces.
POST /api/v1/lakehouseopt/getNamespaces
Description
Get all namespaces in a catalog.
Parameters
| Type | Name | Schema |
|---|---|---|
Body |
input |
Responses
| HTTP Code | Description | Schema |
|---|---|---|
200 |
Expected response to a valid request. |
|
default |
The default response on an error. |
Fetches the policy details.
POST /api/v1/lakehouseopt/getPolicy
Description
Fetches policy details like version IDs, policy actions, scope of the policy, status and associations.
Parameters
| Type | Name | Schema |
|---|---|---|
Body |
input |
Responses
| HTTP Code | Description | Schema |
|---|---|---|
200 |
Expected response to a valid request. |
|
default |
The default response on an error. |
get all policy names associated with a namespace.
POST /api/v1/lakehouseopt/getPolicyNames
Description
get policy names associated with a namespace.
Parameters
| Type | Name | Schema |
|---|---|---|
Body |
input |
Responses
| HTTP Code | Description | Schema |
|---|---|---|
200 |
Expected response to a valid request. |
|
default |
The default response on an error. |
Get scripts.
POST /api/v1/lakehouseopt/getScripts
Description
Get scripts which are default or defined at catalog level.
Parameters
| Type | Name | Schema |
|---|---|---|
Body |
input |
Responses
| HTTP Code | Description | Schema |
|---|---|---|
200 |
Expected response to a valid request. |
|
default |
The default response on an error. |
Get table names in a namespace.
POST /api/v1/lakehouseopt/getTableNames
Description
Get table names in a namespace.
Parameters
| Type | Name | Schema |
|---|---|---|
Body |
input |
Responses
| HTTP Code | Description | Schema |
|---|---|---|
200 |
Expected response to a valid request. |
|
default |
The default response on an error. |
get policies of a table in a namespace.
POST /api/v1/lakehouseopt/getTablePolicies
Description
get policies of a table in a namespace.
Parameters
| Type | Name | Schema |
|---|---|---|
Body |
input |
Responses
| HTTP Code | Description | Schema |
|---|---|---|
200 |
Expected response to a valid request. |
|
default |
The default response on an error. |
Get table status details.
POST /api/v1/lakehouseopt/getTableStatusDetails
Description
Get details on table’s current status.
Parameters
| Type | Name | Schema |
|---|---|---|
Body |
input |
Responses
| HTTP Code | Description | Schema |
|---|---|---|
200 |
Expected response to a valid request. |
|
default |
The default response on an error. |
Get all supported timezones.
POST /api/v1/lakehouseopt/getTimezones
Description
Return all supported timezones to schedule the policy.
Parameters
| Type | Name | Schema |
|---|---|---|
Body |
input |
Responses
| HTTP Code | Description | Schema |
|---|---|---|
200 |
Expected response to a valid request. |
|
default |
The default response on an error. |
List environments.
POST /api/v1/lakehouseopt/listEnvironments
Description
Returns the list of environments along with the CLO Data Hub details if it’s enabled.
Parameters
| Type | Name | Schema |
|---|---|---|
Body |
input |
Responses
| HTTP Code | Description | Schema |
|---|---|---|
200 |
Expected response to a valid request. |
|
default |
The default response on an error. |
Lists policies.
POST /api/v1/lakehouseopt/listPolicies
Description
Lists policies across all namespaces or a particular namespace.
Parameters
| Type | Name | Schema |
|---|---|---|
Body |
input |
Responses
| HTTP Code | Description | Schema |
|---|---|---|
200 |
Policy list response |
|
default |
The default response on an error. |
List tables in a namespace.
POST /api/v1/lakehouseopt/listTables
Description
list tables in a namespace.
Parameters
| Type | Name | Schema |
|---|---|---|
Body |
input |
Responses
| HTTP Code | Description | Schema |
|---|---|---|
200 |
Expected response to a valid request. |
|
default |
The default response on an error. |
Retrieves CLO maintenance tasks.
POST /api/v1/lakehouseopt/listTasks
Description
Retrieves CLO maintenance tasks for a given namespace.
Parameters
| Type | Name | Schema |
|---|---|---|
Body |
input |
Responses
| HTTP Code | Description | Schema |
|---|---|---|
200 |
List of tasks. |
|
default |
The default response on an error. |
Pause a table.
POST /api/v1/lakehouseopt/pauseTable
Description
Pause all maintenance actions on a table.
Parameters
| Type | Name | Schema |
|---|---|---|
Body |
input |
Responses
| HTTP Code | Description | Schema |
|---|---|---|
200 |
Expected response to a valid request. |
|
default |
The default response on an error. |
Unpause a table.
POST /api/v1/lakehouseopt/unpauseTable
Description
Resume maintenance actions on a table.
Parameters
| Type | Name | Schema |
|---|---|---|
Body |
input |
Responses
| HTTP Code | Description | Schema |
|---|---|---|
200 |
Expected response to a valid request. |
|
default |
The default response on an error. |
Unsubscribe a policy from the table.
POST /api/v1/lakehouseopt/unsubscribePolicy
Description
Remove a policy associated with the table.
Parameters
| Type | Name | Schema |
|---|---|---|
Body |
input |
Responses
| HTTP Code | Description | Schema |
|---|---|---|
200 |
Expected response to a valid request. |
|
default |
The default response on an error. |
Update an existing policy.
POST /api/v1/lakehouseopt/updatePolicy
Description
Update an existing policy.
Parameters
| Type | Name | Schema |
|---|---|---|
Body |
input |
Responses
| HTTP Code | Description | Schema |
|---|---|---|
200 |
Expected response to a valid request. |
|
default |
The default response on an error. |
Definitions
AssociatedTableObject
Describes association for a table.
| Name | Description | Schema |
|---|---|---|
isAssociated |
The flag to indicate if the table is associated with the policy. TRUE if associated else FALSE. |
boolean |
tableName |
The table name. |
string |
Associations
Association per namespace.
| Name | Description | Schema |
|---|---|---|
namespace |
The namespace name. |
string |
tables |
The list of tables associated for a namespace. |
< string > array |
ChangeTablePolicyRequest
Request object to perform policy change.
| Name | Description | Schema |
|---|---|---|
datahubCrn |
The CRN of the CLO Data Hub. |
string |
namespace |
The name of the namespace. |
string |
operation |
The operation to be performed. APPEND will add provided policies to set of existing associated policies, REMOVEALL will delete all existing associations for this table, REPLACEALL will replace existing associations with provided set of policies. |
enum (APPEND, REMOVEALL, REPLACEALL) |
policies |
The list of policy names. |
< string > array |
tableName |
The name of the table. |
string |
ChangeTablePolicyResponse
Response object of policy change.
Type : object
CreateAssociations
Association to create per namespace.
| Name | Description | Schema |
|---|---|---|
namespace |
The namespace name. |
string |
tables |
The list of tables associated for a namespace. |
< string > array |
CreateAssociationsRequest
Request object to create associations for a policy.
| Name | Description | Schema |
|---|---|---|
associations |
List of associations for each namespace. |
< CreateAssociations > array |
datahubCrn |
The CRN of the CLO Data Hub. |
string |
policyName |
The policy name. |
string |
CreateAssociationsResponse
Response object containing created associations per namespace.
| Name | Description | Schema |
|---|---|---|
associations |
List of associations for each namespace. |
< Associations > array |
CreatePolicyRequest
Request object to create a new policy.
| Name | Description | Schema |
|---|---|---|
datahubCrn |
The CRN of the CLO Data Hub. |
string |
policyName |
The policy name. |
string |
resources |
The policy resources like script and arguments. |
CreatePolicyResponse
Response object for creating policy.
Type : object
CreateTablePoliciesAssociationsRequest
Request object to associate a table with set of policies.
| Name | Description | Schema |
|---|---|---|
datahubCrn |
The CRN of the CLO Data Hub. |
string |
namespace |
The name of the namespace. |
string |
policies |
The list of policy names to be associated. |
< string > array |
tableName |
The name of the table. |
string |
CreateTablePoliciesAssociationsResponse
Response object containing list of policy names associated with the table.
| Name | Description | Schema |
|---|---|---|
policies |
The associated policy names. |
< string > array |
DeletePolicyRequest
Request object specifying the policy and resource scope for deletion.
| Name | Description | Schema |
|---|---|---|
datahubCrn |
The CRN of the CLO Data Hub. |
string |
policyName |
Policy name that needs to be deleted. The version is identified through the resource. |
string |
resourceScope |
Represents the hierarchical level (<catalog>.<namespace>.<table>) at which a policy is defined and needs to be deleted. Give |
string |
DeletePolicyResponse
Response object of delete policy.
| Name | Description | Schema |
|---|---|---|
deletedPolicies |
Number of policy versions deleted. |
integer (int32) |
DirectAssociationDetails
Describes direct table to policy association details per namespace.
| Name | Description | Schema |
|---|---|---|
namespace |
The namespace. |
string |
status |
The namespace status. |
enum (ERROR, SUCCESS, AUTO_PAUSED, USER_PAUSED, PAUSED, UNAVAILABLE, WARNING) |
tables |
The table to policy associations for a namespace |
< TablePolicyAssociation > array |
DownloadPolicyRequest
Request object to get a particular policy version.
| Name | Description | Schema |
|---|---|---|
datahubCrn |
The CRN of the CLO Data Hub. |
string |
policyName |
The name of the policy. |
string |
policyVersion |
The policy version. |
string |
DownloadPolicyResponse
Response object containing the policy script and arguments.
| Name | Description | Schema |
|---|---|---|
arguments |
The policy arguments. |
string (byte) |
script |
The policy script. |
string (byte) |
DryRunResult
The dry run result metadata.
| Name | Description | Schema |
|---|---|---|
actions |
The list of actions that would be performed on the table if the policy is executed. |
< string > array |
details |
The detailed output of the dry run in a base64 encoded string. |
string (byte) |
Environment
The environment details.
| Name | Description | Schema |
|---|---|---|
cloudPlatform |
The cloud platform of the environment, possible values are AZURE or AWS. |
string |
datahubCrn |
The CRN of the CLO Data Hub. If CLO is not enabled it will be null. |
string |
datahubName |
The name of the CLO Data Hub. If CLO is not enabled it will be null. |
string |
environmentCrn |
The CRN of the environment. |
string |
environmentName |
The name of the environment. |
string |
isCloEnabled |
The flag indicating if CLO is enabled. If enabled it is true else false. |
boolean |
status |
The CLO Data Hub status. If CLO is not enabled it will be null. |
string |
Error
An object returned on an error.
| Name | Description | Schema |
|---|---|---|
code |
The error code. |
string |
message |
The error message. |
string |
ExecutePolicyRequest
Request object for executing a policy on a table.
| Name | Description | Schema |
|---|---|---|
datahubCrn |
The CRN of the Cloudera Lakehouse Optimizer Data Hub. |
string |
dryRun |
Flag to indicate if the execution is a dry run. If true, it will perform a dry run else actual execution. |
boolean |
namespace |
Namespace name. |
string |
policyName |
Policy name. |
string |
tableName |
Table name. |
string |
ExecutePolicyResponse
Response object of policy execution on a table.
| Name | Description | Schema |
|---|---|---|
dryRunResult |
The dry run result. This field will be present only if the request had dryRun as true. |
|
executionResult |
The execution result. This field will be present only if the request had dryRun as false. |
ExecutionResult
The execution result metadata.
| Name | Description | Schema |
|---|---|---|
details |
The detailed output of the execution task metadata in a base64 encoded string. |
string (byte) |
taskId |
The unique identifier for the maintenance task in UUID format. |
string |
GetAssociatedNamespacesObject
Describes association for a namespace.
| Name | Description | Schema |
|---|---|---|
isAssociated |
The flag to indicate if the namespace is associated with the policy. TRUE if associated else FALSE. |
boolean |
namespace |
The namespace. |
string |
GetAssociatedNamespacesRequest
Request object to get the associated namespaces for a policy.
| Name | Description | Schema |
|---|---|---|
datahubCrn |
The CRN of the CLO Data Hub. |
string |
policyName |
The policy name. |
string |
GetAssociatedNamespacesResponse
Response object containing all namespaces and a flag to indicate if it’s associated with the particular namespace.
| Name | Description | Schema |
|---|---|---|
associatedNamespaces |
The namespaces. |
< GetAssociatedNamespacesObject > array |
GetAssociatedTablesObject
Describes association for a namespace.
| Name | Description | Schema |
|---|---|---|
namespace |
The namespace. |
string |
tables |
The list of table names in the namespace and a flag to indicate if it’s associated. |
< AssociatedTableObject > array |
GetAssociatedTablesRequest
Request object to get the associated tables for a policy.
| Name | Description | Schema |
|---|---|---|
datahubCrn |
The CRN of the CLO Data Hub. |
string |
policyName |
The policy name. |
string |
GetAssociatedTablesResponse
Response object containing namespace wise table names and a flag to indicate if it’s associated with the table.
| Name | Description | Schema |
|---|---|---|
associatedTables |
The namespace wise table list. |
< GetAssociatedTablesObject > array |
GetAssociationDetailsRequest
Request object for getting the association details.
| Name | Description | Schema |
|---|---|---|
datahubCrn |
The CRN of the Cloudera Lakehouse Optimizer Data Hub. |
string |
GetAssociationDetailsResponse
Response object containing the association details. It contains direct table to policy associations and policy to entire namespace associations.
| Name | Description | Schema |
|---|---|---|
directionAssociation |
The direct table to policy associations for each namespace. |
< DirectAssociationDetails > array |
starAssociation |
The policy to entire namespace associations for each catalog. |
< StarAssociationDetails > array |
GetAssociationsRequest
Request object to get associations for a policy.
| Name | Description | Schema |
|---|---|---|
datahubCrn |
The CRN of the CLO Data Hub. |
string |
policyName |
The policy name. |
string |
GetAssociationsResponse
Response object containing table associations per namespace.
| Name | Description | Schema |
|---|---|---|
associations |
List of associations for each namespace. |
< Associations > array |
GetCloDatahubRequest
Request object to get CLO Data Hub.
| Name | Description | Schema |
|---|---|---|
environmentCrn |
The CRN of the environment. |
string |
GetCloDatahubResponse
Response object containing the CLO Data Hub details.
| Name | Description | Schema |
|---|---|---|
cloudPlatform |
The cloud platform of the environment, possible values are AZURE or AWS. |
string |
datahubCrn |
The CRN of the CLO Data Hub. |
string |
datahubName |
The name of the CLO Data Hub. |
string |
environmentCrn |
The CRN of the environment. |
string |
environmentName |
The name of the environment. |
string |
status |
The CLO Data Hub status. |
string |
GetDatahubCrnRequest
Request object to get CLO Data Hub CRN.
| Name | Description | Schema |
|---|---|---|
environmentCrn |
The CRN of the environment. |
string |
GetDatahubCrnResponse
Response object containing the CLO Data Hub CRN.
| Name | Description | Schema |
|---|---|---|
datahubCrn |
The CRN of the CLO Data Hub. |
string |
GetHealthRequest
Request object for health check.
| Name | Description | Schema |
|---|---|---|
datahubCrn |
The CRN of the CLO Data Hub. |
string |
scope |
Health check scope. The supported values are "Full" and "Partial". The "Full" performs a deep health check along with livy session creation. The "Partial" performs a shallow health check which doesn’t involve session creation. |
enum (Full, Partial) |
GetHealthResponse
Response object for health check.
| Name | Description | Schema |
|---|---|---|
action |
Action performed. For example, READ or NOOP or CREATE. |
string |
result |
Map containing the service wise health check result. |
< string, HealthCheckResult > map |
GetNamespacesRequest
The request object to get list of namespaces in a catalog.
| Name | Description | Schema |
|---|---|---|
datahubCrn |
The CRN of the CLO Data Hub. |
string |
GetNamespacesResponse
The response object with list of namespaces in a catalog.
| Name | Description | Schema |
|---|---|---|
namespaces |
The list of namespace names. |
< string > array |
GetPolicyNamesRequest
Request object to get list of policy names for a namespace or across all namespaces.
| Name | Description | Schema |
|---|---|---|
datahubCrn |
The CRN of the CLO Data Hub. |
string |
namespace |
The name of the namespace. Provide * to list policies across all namespaces. |
string |
GetPolicyNamesResponse
Response object containing list of policy names for a namespace or across all namespaces.
| Name | Description | Schema |
|---|---|---|
policyNames |
all policy names for a namespace. |
< string > array |
GetPolicyRequest
Request object to fetch the details of a policy.
| Name | Description | Schema |
|---|---|---|
datahubCrn |
The CRN of the CLO Data Hub. |
string |
policyName |
The name of the policy. |
string |
GetPolicyResponse
Response object containing the policy detail which includes version IDs, associations, scope and status.
| Name | Description | Schema |
|---|---|---|
policyDetail |
Policy detail corresponding to a unique policy version. |
|
versions |
List of all version IDs of the policy. |
< string > array |
policyDetail
| Name | Description | Schema |
|---|---|---|
arguments |
JSON containing the action specific arguments and other user defined arguments. |
string (byte) |
associations |
The list containing table associations for each namespace. |
< NamespaceAssociation > array |
creationTime |
The policy creation time in epoch milliseconds. |
integer (int64) |
lastExecutionTime |
The recent policy execution epoch time in milliseconds. |
integer (int64) |
scope |
The scope of the policy. It can be Catalog or Namespace. |
string |
tableCount |
The count of associated tables. |
integer (int32) |
version |
The policy version which is a UUID. |
string |
GetScriptsRequest
Request object to fetch all scripts.
| Name | Description | Schema |
|---|---|---|
datahubCrn |
The CRN of the CLO Data Hub. |
string |
GetScriptsResponse
Response object containing list of scripts.
| Name | Description | Schema |
|---|---|---|
scripts |
List of scripts. |
< Script > array |
GetTableNamesRequest
Request object to get all tables in a given namespace.
| Name | Description | Schema |
|---|---|---|
datahubCrn |
The CRN of the CLO Data Hub. |
string |
namespace |
The namespace name. |
string |
GetTableNamesResponse
Response object containing table names in a namespace.
| Name | Description | Schema |
|---|---|---|
tables |
The list of table names. |
< string > array |
GetTablePoliciesRequest
Request object to get list of policies associated with a table.
| Name | Description | Schema |
|---|---|---|
datahubCrn |
The CRN of the CLO Data Hub. |
string |
namespace |
The name of the namespace. |
string |
tableName |
The name of the table. |
string |
GetTablePoliciesResponse
Response object to get list of policies associated with a table.
| Name | Description | Schema |
|---|---|---|
policies |
List of all policies associated with a table. |
< TablePoliciesObject > array |
GetTableStatusDetailsRequest
Request object to get the table status details.
| Name | Description | Schema |
|---|---|---|
datahubCrn |
The CRN of the CLO Data Hub. |
string |
namespace |
The namespace. |
string |
policyName |
The policy name. |
string |
status |
The table status. It can be UNAVAILABLE, SUCCESS, ERROR, PAUSED. UNAVAILABLE if no tasks ran recently, SUCCESS if recent task got completed successfully, ERROR if recent task has failed, PAUSED if the table is in paused state. |
enum (UNAVAILABLE, SUCCESS, ERROR, PAUSED) |
tableName |
The table name. |
string |
GetTableStatusDetailsResponse
Returns the table’s current status details.
| Name | Description | Schema |
|---|---|---|
pausedTable |
The paused table details. |
|
recentTask |
The recent maintenance task that ran on the table. |
GetTimezonesRequest
Request object to get all supported timezones to define policy schedule.
Type : object
GetTimezonesResponse
Response object containing all supported timezones to define policy schedule.
| Name | Description | Schema |
|---|---|---|
timezones |
The list of all supported timezones. |
< TimezoneObject > array |
HealthCheckResult
Health check result.
| Name | Description | Schema |
|---|---|---|
details |
Map with additional service specific details. |
< string, string > map |
duration |
Health check duration in millis. |
integer (int64) |
error |
Exception during health checks. |
string |
isHealthy |
Service health status. The supported values are true or false. "true" represents the service is healthy and "false" represents the service is in an unhealthy state. |
boolean |
message |
Service health check message. |
string |
time |
Time when the health check was performed. It will be in milliseconds. |
integer (int64) |
ListEnvironmentsRequest
The request object to get environments.
| Name | Description | Schema |
|---|---|---|
pageSize |
The page size. |
integer (int32) |
pageToken |
The page token. If the token value is 'ALL' then it will list all existing environments irrespective of pageSize. |
string |
ListEnvironmentsResponse
The response object containing environment and CLO Data Hub details.
| Name | Description | Schema |
|---|---|---|
environments |
The list containing environment details. |
< Environment > array |
nextPageToken |
The page token for requesting the next page of results. |
string |
totalEnvironments |
This field represents the total number of environments. |
integer (int32) |
ListPoliciesRequest
Request object to get list of policies across all namespaces or a particular namespace.
| Name | Description | Schema |
|---|---|---|
datahubCrn |
The CRN of the CLO Data Hub. |
string |
namespace |
The namespace name. If set, then it will list policies from this namespace. Omitting it, will list policies across all namespaces. |
string |
ListPoliciesResponse
Response object containing the list of policies.
| Name | Description | Schema |
|---|---|---|
policies |
List of all policies for a particular namespace or across all namespaces. |
< PolicyObject > array |
ListTablesRequest
Request object to get list of tables for a particular namespace.
| Name | Description | Schema |
|---|---|---|
datahubCrn |
The CRN of the CLO Data Hub. |
string |
namespace |
The namespace name for which table and it’s policies will be listed. |
string |
ListTablesResponse
Response object containing the list of tables.
| Name | Description | Schema |
|---|---|---|
tables |
List of all tables for a particular namespace |
< TableObject > array |
ListTasksRequest
Request object for listing tasks for a namespace.
| Name | Description | Schema |
|---|---|---|
datahubCrn |
The CRN of the CLO Data Hub. |
string |
namespace |
Namespace name to filter tasks. |
string |
pageSize |
The number of tasks. |
integer (int32) |
pageToken |
A token to specify where to start paginating. This is the nextToken from a previously truncated response. |
string |
ListTasksResponse
Response object of list tasks.
| Name | Description | Schema |
|---|---|---|
nextPageToken |
The token to use when requesting the next set of results. If not present, there are no additional results. |
string |
tasks |
The tasks list. |
< TaskObject > array |
NamespaceAssociation
The table associations per namespace.
| Name | Description | Schema |
|---|---|---|
namespace |
The name of the namespace. |
string |
status |
The namespace status. Possible values are ERROR, SUCCESS, PAUSED, AUTO_PAUSED, USER_PAUSED, UNAVAILABLE and WARNING. PAUSED indicated that namespace is paused for maintenance actions, AUTO_PAUSED indicates namespace is paused automatically due to errors, USER_PAUSED indicates paused by user, ERROR indicates that recent task has failed or a table is in paused state due to exceptions, WARNING if a table is paused by user, SUCCESS if there are no recent task failures or paused tables, UNAVAILABLE if no tasks have run yet. |
enum (ERROR, SUCCESS, AUTO_PAUSED, USER_PAUSED, PAUSED, UNAVAILABLE, WARNING) |
tableAssociations |
The list of associated tables and their details for a namespace. |
< TableAssociation > array |
NamespacePolicyAssociation
Describes policy to namespace associations.
| Name | Description | Schema |
|---|---|---|
namespace |
The namespace. |
string |
policies |
The list of associated policies for the namespace. |
< string > array |
status |
The namespace status. |
enum (ERROR, SUCCESS, PAUSED, WARNING, UNAVAILABLE) |
PauseTableRequest
Request object to pause a table.
| Name | Description | Schema |
|---|---|---|
datahubCrn |
The CRN of the CLO Data Hub. |
string |
namespace |
The name of the namespace. |
string |
tableName |
The name of the table. |
string |
PauseTableResponse
Response object for pausing table.
Type : object
PausedDetails
The paused details.
| Name | Description | Schema |
|---|---|---|
pausedSince |
The paused time in ISO format. |
string |
reasons |
The list containing the reasons for table getting paused. |
< string > array |
PausedTable
The paused table details.
| Name | Description | Schema |
|---|---|---|
details |
The paused details. |
|
message |
The paused message. |
string |
PolicyObject
The policy object containing name, status and other details.
| Name | Description | Schema |
|---|---|---|
creationTime |
The policy creation time in epoch milliseconds. |
integer (int64) |
isDefault |
Flag to indicate if the policy is a default one provided by Cloudera. Policy is default if true else false. |
boolean |
lastExecutionTime |
The recent task execution time in epoch milliseconds. |
integer (int64) |
policyName |
The policy name. |
string |
status |
The policy status. |
enum (ERROR, SUCCESS, PAUSED, UNAVAILABLE) |
tableCount |
The number of tables associated with this policy. |
integer (int32) |
taskCount |
The number of tasks ran for this policy. |
integer (int32) |
PolicyResource
The policy resources such as policy script and arguments.
| Name | Description | Schema |
|---|---|---|
arguments |
A base64 encoded version of policy arguments json. |
string |
script |
A base64 encoded jexl script. |
string |
Script
The policy script.
| Name | Description | Schema |
|---|---|---|
description |
The script description. |
string |
name |
The script name. |
string |
uri |
The script uri which follows CLO uri format. EG, dlm://tps/hive/snapshot. |
string |
StarAssociationDetails
Describes policy to entire namespace association details per catalog.
| Name | Description | Schema |
|---|---|---|
catalog |
The catalog. |
string |
namespaces |
The policy to namespace associations for a catalog. |
< NamespacePolicyAssociation > array |
status |
The catalog status. |
enum (ERROR, SUCCESS, PAUSED, WARNING, UNAVAILABLE) |
TableAssociation
The object containing information about a table to policy association.
| Name | Description | Schema |
|---|---|---|
lastExecutionTime |
The time in epoch milliseconds of recent CLO task that ran for the table. |
integer (int64) |
name |
The table name. |
string |
namespace |
The namespace name. |
string |
status |
The table status. |
enum (ERROR, SUCCESS, PAUSED, UNAVAILABLE) |
taskCount |
The count of CLO tasks ran for the table. |
integer (int32) |
version |
The policy version applicable to this table. |
string |
TableObject
The table object containing name, status and other details.
| Name | Description | Schema |
|---|---|---|
lastExecutionTime |
The last task execution time in epoch milliseconds. |
integer (int64) |
namespace |
The name of the namespace. |
string |
policies |
The list of associated policies. |
< string > array |
status |
The table status. |
enum (ERROR, SUCCESS, AUTO_PAUSED, USER_PAUSED, PAUSED, UNAVAILABLE, WARNING) |
tableName |
The name of the table. |
string |
TablePoliciesObject
The table object containing details of policy association.
| Name | Description | Schema |
|---|---|---|
lastExecutionTime |
The last task execution time in epoch milliseconds. |
integer (int64) |
policyName |
The name of the policy. |
string |
status |
The status of the policy on this table. |
enum (ERROR, SUCCESS, AUTO_PAUSED, USER_PAUSED, PAUSED, UNAVAILABLE, WARNING) |
taskCount |
The number of tasks ran for this policies on this table. |
integer (int32) |
TablePolicyAssociation
Describes table to policy associations.
| Name | Description | Schema |
|---|---|---|
lastExecutionEpoch |
The last executed maintenance task in epoch milliseconds. |
integer (int64) |
policies |
The list of associated policies for the table. |
< string > array |
status |
The table status. |
enum (ERROR, SUCCESS, USER_PAUSED, AUTO_PAUSED, PAUSED, UNAVAILABLE, WARNING) |
tableName |
The table name. |
string |
Task
The maintenance task that ran on a table.
| Name | Description | Schema |
|---|---|---|
actions |
The list of actions that ran with a policy on a table. |
< TaskAction > array |
lastExecutionTime |
The recent policy execution epoch time in milliseconds. |
integer (int64) |
policyName |
Policy name. |
string |
tableName |
Table name. |
string |
TaskAction
Describes metadata for action on the table.
| Name | Description | Schema |
|---|---|---|
action |
Action that was performed on the table. |
string |
status |
Status of the action. |
string |
TaskObject
Task metadata for a policy on a table.
| Name | Description | Schema |
|---|---|---|
catalog |
The catalog name. |
string |
createdAt |
The task creation time in epoch milliseconds. |
integer (int64) |
details |
A base64 encoded version of task details json. |
string (byte) |
namespace |
The namespace name. |
string |
policy |
The policy name. |
string |
status |
The task status. It can be INIT, SUBMITTED, COMPLETED, FAILED. Initially the task status would be INIT and transition to SUBMITTED after submitting to spark. Based on the spark execution it changed to COMPLETED, FAILED. |
enum (INIT, SUBMITTED, COMPLETED, FAILED) |
table |
The table name. |
string |
taskId |
Unique identified for task in UUID format. |
string |
TimezoneObject
Describes a timezone.
| Name | Description | Schema |
|---|---|---|
displayName |
The timezone display name. |
string |
id |
The timezone id. |
string |
offset |
The offset in milliseconds from UTC. |
integer (int32) |
UnpauseTableRequest
Request object to unpause a table.
| Name | Description | Schema |
|---|---|---|
datahubCrn |
The CRN of the CLO Data Hub. |
string |
namespace |
The name of the namespace. |
string |
tableName |
The name of the table. |
string |
UnpauseTableResponse
Response object to unpause a table.
Type : object
UnsubscribePolicyRequest
Request object to unsubscribe a policy from table.
| Name | Description | Schema |
|---|---|---|
datahubCrn |
The CRN of the CLO Data Hub. |
string |
namespace |
The name of the namespace. |
string |
policyName |
The name of the policy that is to be unsubscribed. |
string |
tableName |
The name of the table. |
string |
UnsubscribePolicyResponse
Response object of unsubscribing a policy from table.
| Name | Description | Schema |
|---|---|---|
policies |
The list of policy names which are associated with the table. |
< string > array |
UpdatePolicyRequest
Request object to update an existing policy.
| Name | Description | Schema |
|---|---|---|
datahubCrn |
The CRN of the CLO Data Hub. |
string |
policyName |
The policy name. |
string |
resources |
The policy resources like script and arguments. |
UpdatePolicyResponse
Response object for updating policy.
Type : object